MODULE Popup;

(*************************************************************************
 *
 *  Module : Popup
 *  Author : William W. Smith
 *           (Modified by Lee Iverson for general Sapphire use)
 *
 *  Abstract :
 *    This module provides routines to use popup menus.
 *
 *  (c) Siemens Corp. 1984
 *************************************************************************)

EXPORTS

IMPORTS SapphDefs FROM SapphDefs;

CONST
     CalcWidth = -1; { input value meaning calculate the width of the popup }
                     { menu. }
     NilList = nil;

TYPE
   PopList = ^PopListElem;
   PopListElem = record
                   str: String;
                   ptr: Pointer;
                   next: PopList;
                 end;

   PopupReturn = ( KeyPress, ButtonPress, OffMenuKeyPress, OffMenuButtonPress );


FUNCTION GetPopupEntry (
               PVP: Viewport;
               Prompt: String;
               DisplayItems: PopList;
               CenterX: Integer;
               CenterY: Integer;
               width: Integer;
           var RetType: PopupReturn
         ) : PopList;

  { Display popup menu and wait for a key or button press }


PROCEDURE BuildPopupList(
                str: String;
                ptr: Pointer;
            var PopupList : PopList
          );

  { Add the given string and UID to the end of the list of popup menu items. } 


PROCEDURE DestroyPopup(
            PopupList: PopList
          );

  { Delete a popuplist and each of the strings that is the items name }

PRIVATE

{$INCLUDE popup.impl}

.
